<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center column>

        <v-card width="90%">
            <v-card-title>
                <v-layout column>
                    <v-layout wrap>

                        <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                            <v-select
                                    v-model="filter.status"
                                    :items="cargoStatus"
                                    item-text="text"
                                    item-value="index"
                                    outlined
                                    label="وضعیت درخواست"
                                    single-line
                                    @change="setStatus"
                            ></v-select>
                        </v-flex>
                        <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                            <v-autocomplete
                                    v-model="filter.owner"
                                    label="صاحب بار"
                                    append-icon="search"
                                    :isLoading="isLoading"
                                    :search-input.sync="searchOwner"
                                    :items="searchedOwners"
                                    item-text="name"
                                    :filter="customFilter"
                                    return-object
                                    @change="setSelectedOwner"
                            ></v-autocomplete>
                        </v-flex>

                        <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                            <v-autocomplete
                                    v-model="filter.receiver"
                                    label="راننده / باربری"
                                    append-icon="search"
                                    :isLoading="isLoading"
                                    :search-input.sync="searchReceiver"
                                    :items="searchedReceiver"
                                    item-text="name"
                                    :filter="customFilter"
                                    return-object
                                    @change="setSelectedReceiver"
                            ></v-autocomplete>
                        </v-flex>


                        <v-flex class="pl-1 p-r1" xs12 sm12 md12>
                            <v-layout wrap>
                                <v-flex xs12 sm12 md4>
                                    <v-layout row>
                                        <h5 class="ma-1 mr-3">
                                            از:
                                        </h5>
                                        <date-picker @input="setStartTime" color="#b71c1c" type="datetime"
                                                     :value="filter.start_time"></date-picker>
                                    </v-layout>
                                </v-flex>
                                <v-flex xs12 sm12 md4>
                                    <v-layout row>
                                        <h5 class="ma-1 mr-3">
                                            تا:
                                        </h5>
                                        <date-picker @input="setEndTime" color="#b71c1c" type="datetime"
                                                     :value="filter.end_time"></date-picker>
                                    </v-layout>
                                </v-flex>
                            </v-layout>
                        </v-flex>
                    </v-layout>
                    <v-layout class="ma-2" row>
                        <v-btn
                                color="green"
                                dark
                                small
                                top
                                center
                                @click="readData"
                        >
                            اعمال فیلتر ها
                        </v-btn>

                        <v-btn
                                color="error"
                                dark
                                small
                                top
                                center
                                @click="removeFilter"
                        >
                            حذف فیلتر ها
                        </v-btn>
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-card width="90%" class="mt-2 scroll-y">
            <v-card-title>
                <v-layout column>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.city_origin !== null ? item.city_origin.name : ""}}</td>
                            <td>{{ item.city_destination !== null ? item.city_destination.name : ""}}</td>
                            <td>{{ item.owner !== null ? item.owner.name : "ندارد"}}</td>
                            <td>{{ item.owner !== null ? item.owner.phone_number : "ندارد"}}</td>
                            <td>{{ item.receiver !== null ? item.receiver.name : "ندارد"}}</td>
                            <td>{{ cargoStatus[item.last_status].text}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                    v-show = "item.last_status < 10"
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>
                            </td>
                            <td>
                                <v-btn v-show = "item.last_status < 10" small class="mr-2" color="error" @click="cancel(item)">
                                    لغو
                                </v-btn>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>
                            <v-flex xs12 md6 sm6>
                                <v-text-field @change="setOriginAddress" v-model="selectedItem.origin_address"
                                              label="آدرس مبدا"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md6 sm6>
                                <v-text-field @change="setDestinationAddress" v-model="selectedItem.destination_address"
                                              label="آدرس مبدا"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md3 sm6>
                                <v-text-field type="number" @change="setCargoCostMin"
                                              v-model="selectedItem.cargo_cost_min"
                                              label="حداقل ارزش بار"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md3 sm6>
                                <v-text-field type="number" @change="setCargoCostMax"
                                              v-model="selectedItem.cargo_cost_max"
                                              label="حداکثر ارزش بار"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md3 sm6>
                                <v-text-field type="number" @change="setCargoWeightMin"
                                              v-model="selectedItem.cargo_weight_min"
                                              label="حداقل وزن بار"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md3 sm6>
                                <v-text-field type="number" @change="setCargoCostMax"
                                              v-model="selectedItem.cargo_weight_max"
                                              label="حداکثر وزن بار"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md6 sm6>
                                <v-text-field @change="setDescription" v-model="selectedItem.description"
                                              label="توضیحات"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md6 sm6>
                                <v-text-field @change="setMessageToDriver" v-model="selectedItem.message_to_driver"
                                              label="پیغام به راننده"></v-text-field>
                            </v-flex>


                            <v-flex class="pl-1 p-r1" xs12 sm12 md12>
                                <v-layout wrap>
                                    <v-flex xs12 sm12 md6>
                                        <v-layout row>
                                            <h5 class="ma-1">
                                                زمان بارگیری :
                                            </h5>
                                            <date-picker @input="setLoadingStartTime" color="#b71c1c" type="datetime"
                                                         :value="selectedItem.loading_start_time"></date-picker>
                                        </v-layout>
                                    </v-flex>
                                    <v-flex xs12 sm12 md6>
                                        <v-layout row>
                                            <h5 class="ma-1">
                                                زمان تخلیه بار :
                                            </h5>
                                            <date-picker @input="setEvacuationStartTime" color="#b71c1c" type="datetime"
                                                         :value="selectedItem.evacuation_start_time"></date-picker>
                                        </v-layout>
                                    </v-flex>
                                </v-layout>
                            </v-flex>

                            <v-flex class="pl-1 p-r1" xs12 sm12 md4>
                                <v-autocomplete
                                        v-model="selectedItem.receiver"
                                        label="راننده / باربری"
                                        append-icon="search"
                                        :isLoading="isLoadingAdd"
                                        :search-input.sync="searchReceiverAdd"
                                        :items="searchedReceiverAdd"
                                        item-text="name"
                                        :filter="customFilter"
                                        return-object
                                        @change="setSelectedReceiverAdd"
                                ></v-autocomplete>
                            </v-flex>

                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    Are you sure that you want delete this contact?
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="detailsDialog"
                dark
                hide-overlay
                persistent
                width="80%"
        >
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog v-model="selectCity" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                        v-model="selectedProvince"
                                        :items="province"
                                        item-text="name"
                                        outlined
                                        label="استان را انتخاب کنید"
                                        single-line
                                        @change="getCity"
                                        return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                        v-show="this.cityPending === false"
                                        v-model="selectedCity"
                                        :items="city"
                                        item-text="name"
                                        outlined
                                        label="شهر را انتخاب کنید"
                                        single-line
                                        @change="setSelectedCity"
                                        return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideSelectCity">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="saveSelectedItemCity">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="WaitDialog"
                dark
                hide-overlay
                persistent
                width="300"
        >
            <v-card
                    color="primary"
                    dark
            >
                <v-card-text>
                    لطفا منتظر بمانید
                    <v-progress-linear
                            indeterminate
                            color="white"
                            class="mb-0"
                    ></v-progress-linear>
                </v-card-text>
            </v-card>
        </v-dialog>

    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "cargo",
        methods: {
            ...mapMutations({
                setFreightName: 'cargo/setFreightName',
                setFirstName: 'cargo/setFirstName',
                setLastName: 'cargo/setLastName',
                setUserName: 'cargo/setUserName',
                setPhoneNumber: 'cargo/setPhoneNumber',
                setTelephoneNumber: 'cargo/setTelephoneNumber',
                setPassword: 'cargo/setPassword',
                setSelectedItem: 'cargo/setSelectedItem',
                showAddDialog: 'cargo/showAddDialog',
                hideAddDialog: 'cargo/hideAddDialog',
                showDeleteDialog: 'cargo/showDeleteDialog',
                hideDeleteDialog: 'cargo/hideDeleteDialog',
                showSelectCity: 'cargo/showSelectCity',
                hideSelectCity: 'cargo/hideSelectCity',
                showCityPending: 'cargo/showCityPending',
                hideCityPending: 'cargo/hideCityPending',
                setStatus: 'cargo/setStatus',
                setFilterPhoneNumber: 'cargo/setFilterPhoneNumber',
                setProvince: 'cargo/setProvince',
                setCity: 'cargo/setCity',
                setSelectedProvince: 'cargo/setSelectedProvince',
                setSelectedCity: 'cargo/setSelectedCity',
                setSelectedItemCity: 'cargo/setSelectedItemCity',
                setStartTime: 'cargo/setStartTime',
                setEndTime: 'cargo/setEndTime',
                setSelectedOwner: 'cargo/setSelectedOwner',
                setSelectedReceiver: 'cargo/setSelectedReceiver',
                setOriginAddress: 'cargo/setOriginAddress',
                setDestinationAddress: 'cargo/setDestinationAddress',
                setCargoCostMin: 'cargo/setCargoCostMin',
                setCargoCostMax: 'cargo/setCargoCostMax',
                setCargoWeightMin: 'cargo/setCargoWeightMin',
                setCargoWeightMax: 'cargo/setCargoWeightMax',
                setSelectedReceiverAdd: 'cargo/setSelectedReceiverAdd',
                setDescription: 'cargo/setDescription',
                setMessageToDriver: 'cargo/setMessageToDriver',
                setEvacuationStartTime: 'cargo/setEvacuationStartTime',
                setLoadingStartTime: 'cargo/setLoadingStartTime',
            }),
            ...mapActions({
                readData: 'cargo/readData',
                addOrEdit: 'cargo/addOrEdit',
                deleteOne: 'cargo/deleteOne',
                cancelCargo: 'cargo/cancelCargo',
                getCityByProvince: 'cargo/getCityByProvince',
                removeFilter: 'cargo/removeFilter'
            }),
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    cargo_cost: item.cargo_cost,
                    cargo_cost_min: item.cargo_cost_min,
                    cargo_cost_max: item.cargo_cost_max,
                    cargo_type: item.cargo_type,
                    cargo_type_id: item.cargo_type_id,
                    cargo_weight: item.cargo_weight,
                    cargo_weight_min: item.cargo_weight_min,
                    cargo_weight_max: item.cargo_weight_max,
                    city_destination: item.city_destination,
                    city_origin: item.city_origin,
                    created_at: item.created_at,
                    description: item.description,
                    destination_address: item.destination_address,
                    destination_city_id: item.destination_city_id,
                    destination_latitude: item.destination_latitude,
                    destination_longitude: item.destination_longitude,
                    evacuation_end_time: item.evacuation_end_time,
                    evacuation_start_time: item.evacuation_start_time,
                    last_status: item.last_status,
                    loading_end_time: item.loading_end_time,
                    loading_start_time: item.loading_start_time,
                    message_to_driver: item.message_to_driver,
                    origin_address: item.origin_address,
                    origin_city_id: item.origin_city_id,
                    origin_latitude: item.origin_latitude,
                    origin_longitude: item.origin_longitude,
                    owner: item.owner,
                    owner_id: item.owner_id,
                    point: item.point,
                    price: item.price,
                    receiver: item.receiver,
                    receiver_id: item.receiver_id,
                    updated_at: item.updated_at,
                    vehicle: item.vehicle,
                    vehicle_id: item.vehicle_id,
                });
                console.log(item)
                this.showAddDialog();
            },
            add_Edit() {
                this.addOrEdit();
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
            cancel(item) {
                this.setSelectedItem(item);
                this.cancelCargo(item)
            },
            getCity(item) {
                console.log('item', item);
                this.setSelectedProvince(item);
                this.getCityByProvince();
            },
            saveSelectedItemCity() {
                this.setSelectedItemCity();
                this.hideSelectCity()
            },
            customFilter(item) {
                return item.first_name + " " + item.last_name;
            },
        },
        computed: {
            ...mapState({
                allData: state => state.cargo.allData,
                AddDialog: state => state.cargo.AddDialog,
                DeleteDialog: state => state.cargo.DeleteDialog,
                selectedItem: state => state.cargo.selectedItem,
                pending: state => state.cargo.pending,
                allDataLoading: state => state.cargo.allDataLoading,
                detailsDialog: state => state.cargo.detailsDialog,
                selectCity: state => state.cargo.selectCity,
                province: state => state.cargo.province,
                city: state => state.cargo.city,
                selectedProvince: state => state.cargo.selectedProvince,
                selectedCity: state => state.cargo.selectedCity,
                cityPending: state => state.cargo.cityPending,
                cargoStatus: state => state.cargo.cargoStatus,
                filter: state => state.cargo.filter,
                searchedOwners: state => state.cargo.searchedOwners,
                searchedReceiver: state => state.cargo.searchedReceiver,
                isLoading: state => state.cargo.isLoading,
                searchedReceiverAdd: state => state.cargo.searchedReceiverAdd,
                isLoadingAdd: state => state.cargo.isLoadingAdd,
                WaitDialog: state => state.cargo.WaitDialog,

            }),
            selectedProvince: {
                set: function (value) {

                },
                get: function () {

                }
            },
            selectedCity: {
                set: function (value) {

                },
                get: function () {

                }
            },
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                searchOwner: null,
                searchReceiver: null,
                searchReceiverAdd: null,
                headers: [
                    {text: 'شهر مبدا', align: 'center', value: 'city_origin.name'},
                    {text: 'شهر مقصد', align: 'center', value: 'city_destination.name'},
                    {text: 'صاحب بار', align: 'center', value: 'owner.name'},
                    {text: 'شماره صاحب بار', align: 'center', value: 'owner.phone_number'},
                    {text: 'دریافت کننده', align: 'center', value: 'receiver'},
                    {text: 'آخرین وضعیت', align: 'center', value: 'last_status'},
                ],
            }
        },
        watch: {
            ...mapActions({
                searchOwner: 'cargo/searchOwner',
                searchReceiver: 'cargo/searchReceiver',
                searchReceiverAdd: 'cargo/searchReceiverAdd',
            }),
        },
    }
</script>
<style scoped>
</style>
